<?php
	require_once 'base.php';
	include_once $babInstallPath."admin/acl.php";
	require_once $GLOBALS['babAddonPhpPath'].'functions.php';

	$babBody->setTitle(undecode_html(bab_translate("Rights on the quizz management addon", $GLOBALS['babAddonFolder'])));

	if (!bab_isUserAdministrator()) {
		$babBody->addError( undecode_html(bab_translate("Acces denied", $GLOBALS['babAddonFolder'])));
		return;
	}

	$res = $babDB->db_query("
	SELECT
	`id_object`
	FROM
	`qui_gest_groups`
	WHERE
	1
	");
	if ($babDB->db_num_rows($res) > 0)
	{
		$arr = $babDB->db_fetch_array($res);
		$id_object = $arr['id_object'];
		
		if( isset($_POST['updateaccess']))
		{
			maclGroups();
			$babBody->addError(undecode_html(bab_translate("Update done", $GLOBALS['babAddonFolder'])));
		}

		$macl = new macl($GLOBALS['babAddonTarget']."/admin", 'idx_value', $babDB->db_escape_string($id_object), 'updateaccess');
		$macl->addtable( 'qm_access_groups',undecode_html(bab_translate("Who can view the quizz results?", $GLOBALS['babAddonFolder'])));
		$macl->filter(0,0,1,1,1);

		$macl->babecho();
	}
	else
	{
		$babBody->addError(undecode_html(bab_translate("You must define the quizz manager groups in the quizz addon.", $GLOBALS['babAddonFolder'])));
	}
	
?>