<?php

require_once $GLOBALS['babAddonPhpPath']."functions.php";

function answers_display_form()
{
	global $babBody;
	class answers_display_form_class
	{
		function answers_display_form_class()
		{
			global $babBody;
			global $babDB;
			
			$this->quizz_id = bab_pp('quizz_id', '');
			$this->max_quizz = bab_pp('max_quizz', '0');
			
			$this->global_view_label = undecode_html(bab_translate("Global answers view", $GLOBALS['babAddonFolder']));
			$this->user_particpations_number_label = undecode_html(bab_translate("User participations number", $GLOBALS['babAddonFolder']));
			
			$this->participants_numbers_label = undecode_html(bab_translate("Distinct participants number:", $GLOBALS['babAddonFolder']));
			$this->statistics_label = undecode_html(bab_translate("Statistics elements", $GLOBALS['babAddonFolder']));
			$this->filled_forms_label = undecode_html(bab_translate("Fullfilled forms number:", $GLOBALS['babAddonFolder']));
			$this->average_filled_forms_label = undecode_html(bab_translate("Average fullfilled forms number:", $GLOBALS['babAddonFolder']));
			$this->max_score_label = undecode_html(bab_translate("Quizz maximum score:", $GLOBALS['babAddonFolder']));
			$this->min_score_label = undecode_html(bab_translate("Quizz minimum score:", $GLOBALS['babAddonFolder']));
			$this->average_score_label = undecode_html(bab_translate("Quizz average score:", $GLOBALS['babAddonFolder']));
			
			$this->questions_label = undecode_html(bab_translate("Questions", $GLOBALS['babAddonFolder']));
			$this->answers_label = undecode_html(bab_translate("Given answers", $GLOBALS['babAddonFolder']));
			$this->score_label = undecode_html(bab_translate("Score", $GLOBALS['babAddonFolder']));
			$this->total_label = undecode_html(bab_translate("Participation total", $GLOBALS['babAddonFolder']));
			
			$this->tiebreaker_label = undecode_html(bab_translate("Tiebreaker", $GLOBALS['babAddonFolder']));
			$this->given_answer_label = undecode_html(bab_translate("Given answer", $GLOBALS['babAddonFolder']));
			$this->difference_label =undecode_html(bab_translate("Difference", $GLOBALS['babAddonFolder']));
			
			$this->print_label = undecode_html(bab_translate("Answers print", $GLOBALS['babAddonFolder']));
			$this->select_label = undecode_html(bab_translate("Select an other quizz", $GLOBALS['babAddonFolder']));
			$res = $babDB->db_query("
			SELECT 
			`nb_max_part` 
			FROM 
			`qui_quizz` 
			WHERE 
			`id` = '".$babDB->db_escape_string($this->quizz_id)."'
			");
			$arr = $babDB->db_fetch_array($res);
			$this->nb_max_part = $arr['nb_max_part'];
			
			$this->res1 = $babDB->db_query("
			SELECT
			DISTINCT 
			`id_user`,
			`nickname`,
			`firstname`,
			`lastname` 
			FROM 
			`qui_results`, 
			`bab_users` 
			WHERE
			`id_user` = `bab_users`.`id`
			AND
			`id_quizz` = '".$babDB->db_escape_string($this->quizz_id)."'
			ORDER BY
			`lastname`, 
			`firstname`,
			`nickname`
			");
			
			$this->count1 = $babDB->db_num_rows($this->res1); // count1 reprsente le nombre de participants distincts au questionnaire
			
			if ($this->count1 === 0) $babBody->addError(undecode_html(bab_translate("No given answer to the quizz!", $GLOBALS['babAddonFolder'])));
			
			$this->max_score = 0;
			$this->total_given_points = 0;
			$this->count6 = 0;
			
			
		}
		////////////////////////////////////////////////////
		function getnext1()
		{
			global $babDB;
			global $babBody;
			static $m=0;
			if ( $m < $this->count1 )
			{
				$arr = $babDB->db_fetch_array($this->res1);
				$this->id_user = $arr['id_user'];
				$this->nickname = $arr['nickname'];
				$this->firstname = mb_convert_case($arr['firstname'], MB_CASE_TITLE, CHARSET);
				$this->lastname = mb_strtoupper($arr['lastname']);
				$res2 = $babDB->db_query("
				SELECT DISTINCT 
				`id_post` 
				FROM 
				`qui_results` 
				WHERE
				`id_user` = '".$babDB->db_escape_string($this->id_user)."'
				AND
				`id_quizz` = '".$babDB->db_escape_string($this->quizz_id)."'
				ORDER BY
				`id_post`
				");
				
				$this->count2 = $babDB->db_num_rows($res2); // count2 reprsente le nombre total de participations du participant au questionnaire
				$this->count6 += $this->count2; // count6 reprsente le nombre total de participations enregistres au questionnaire
				$this->average_form_number = $this->count6 / $this->count1;
				
				$this->result = "";
				
				for ($i = 0; $i < $this->count2; $i++)
				{
					$arr = $babDB->db_fetch_array($res2);
					$id_post = $arr['id_post'];
					
					$this->bgcolor = false;
					$res3 = $babDB->db_query("
					SELECT
					MAX(`date`) AS `participation_date`
					FROM
					`qui_results`
					WHERE
					`id_user` = '".$babDB->db_escape_string($this->id_user)."'
					AND
					`id_post` = '".$babDB->db_escape_string($id_post)."'
					");
					
					$arr = $babDB->db_fetch_array($res3);
					$time = $arr['participation_date'];
					$time = bab_mktime($time);
					$participation_date = mb_strtolower(bab_formatDate('%L', $time));
					$participation_time = mb_strtolower(bab_formatDate('%T', $time));
					$this->participation_label = undecode_html(sprintf(bab_translate("Participation %s of  %s at %s", $GLOBALS['babAddonFolder']), $i + 1, $participation_date, $participation_time ));
					
					$this->result .= "<tr><td colspan=\"3\"><ul><li>".$this->participation_label."</li></ul></td></tr>\r\n";
					$this->bgcolor = !$this->bgcolor;
					if ($this->bgcolor) $this->class = "BabMonthCalendarCurentDayBackground"; else $this->class = "BabForumBackground1";
					$this->result .= "<tr class=\"".$this->class."\"><th>".$this->questions_label."</th><th>".$this->answers_label."</th><th>".$this->score_label."</th></tr>\r\n";
					$total = 0;
					
					$res4 = $babDB->db_query("
					SELECT
					`question`,
					`qui_answer`.`answer`,
					`score`
					FROM
					`qui_results`,
					`qui_question`,
					`qui_answer`
					WHERE
					`id_user` = '".$babDB->db_escape_string($this->id_user)."'
					AND
					`id_post` = '".$babDB->db_escape_string($id_post)."'
					AND
					`qui_question`.`id` = `qui_results`.`id_question`
					AND
					`qui_answer`.`id` = `qui_results`.`answer`
					AND
					`id_typequest` = '1'
					ORDER BY
					`ordering`
					");
					
					$count4 = $babDB->db_num_rows($res4);
					
					for ($k = 0; $k < $count4; $k++)
					{
						$this->bgcolor = !$this->bgcolor;
						if ($this->bgcolor) $this->class = "BabMonthCalendarCurentDayBackground"; else $this->class = "BabForumBackground1";
						$arr = $babDB->db_fetch_array($res4);
						$question = $arr['question'];
						$answer = $arr['answer'];
						$score = $arr['score'];
						$total += $score;
						$this->result .= "<tr class=\"".$this->class."\"><td>".$question."</td><td>".$answer."</td><td align=\"center\">".$score;
					}
					$this->bgcolor = !$this->bgcolor;
					if ($this->bgcolor) $this->class = "BabMonthCalendarCurentDayBackground"; else $this->class = "BabForumBackground1";
					$this->result .= "<tr class=\"".$this->class."\"><td colspan=\"2\"><b><i>".$this->total_label."</i></b></td><td align=\"center\"><b><i>".$total."</i></b></td></tr>";
					
					$this->max_score = max($this->max_score, $total);
					
					if (isset($this->min_score)) $this->min_score = min($this->min_score, $total); else $this->min_score = $total;
					$this->total_given_points += $total;
					$this->average_score = round($this->total_given_points / $this->count6, 1);
					
					$res5 = $babDB->db_query("
					SELECT
					`id_question`,
					`question`,
					`qui_results`.`answer` AS `given_answer`
					FROM
					`qui_results`,
					`qui_question`
					WHERE
					`id_user` = '".$babDB->db_escape_string($this->id_user)."'
					AND
					`id_post` = '".$babDB->db_escape_string($id_post)."'
					AND
					`qui_question`.`id` = `qui_results`.`id_question`
					AND
					`id_typequest` = '2'
					ORDER BY
					`ordering`
					");
					$count5 = $babDB->db_num_rows($res5);
					
					for ($k = 0; $k < $count5; $k++)
					{
						$this->bgcolor = !$this->bgcolor;
						if ($this->bgcolor) $this->class = "BabMonthCalendarCurentDayBackground"; else $this->class = "BabForumBackground1";
						$arr = $babDB->db_fetch_array($res5);
						$id_question = $arr['id_question'];
						$question = $arr['question'];
						$given_answer = $arr['given_answer'];
						$res6 = $babDB->db_query("
						SELECT
						`qui_answer`.`answer` AS `awaited_answer`
						FROM
						`qui_answer`
						WHERE
						`id_question` ='".$babDB->db_escape_string($id_question)."'
						");
						$arr = $babDB->db_fetch_array($res6);
						$awaited_answer = $arr['awaited_answer'];
						$difference = $given_answer - $awaited_answer;
						$this->result .= "<tr class=\"".$this->class."\">\r\n<td colspan=\"3\">\r\n";
						$this->result .= "<table width=\"100%\" align=\"center\" cellpadding=\"0\">";
						$this->result .= "<tr><th>".$this->tiebreaker_label."</th><th align=\"center\">".$this->given_answer_label."</th><th align=\"center\">".$this->difference_label."</th></tr>";
						$this->result .= "<tr><td>".$question."</td><td align=\"center\">".$given_answer."</td><td align=\"center\">".$difference;
						$this->result .= "</table>\r\n";
						$this->result .= "</td>\r\n</tr>\r\n";
					}
				}
				
				$m++;
				return true;
			}
			else
			{
				return false;
			}
		}
		////////////////////////////////////////////////////
	}
	$obj= new answers_display_form_class();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS["babAddonHtmlPath"]."user.html", "answers_display"));
}

function structure_display_form()
{
	global $babBody;
	class structure_display_form_class
	{
		function structure_display_form_class()
		{
			global $babBody;
			global $babDB;
			
			$this->quizz_id = bab_pp('quizz_id', '');
			
			$res = $babDB->db_query("
			SELECT
			`name`, 
			`description`,
			`begin`, 
			`end` 
			FROM 
			`qui_quizz` 
			WHERE 
			`id` = '".$babDB->db_escape_string($this->quizz_id)."'");
			
			$arr = $babDB->db_fetch_array($res);
			$this->name = $arr['name'];
			$this->description = $arr['description'];
			$time = $arr['begin'];
			$time = bab_mktime($time);
			$this->begin = bab_formatDate('%L', $time);
			$time = $arr['end'];
			$time = bab_mktime($time);
			$this->end = bab_formatDate('%L', $time);
			
			$this->general_label = undecode_html(bab_translate("General description", $GLOBALS['babAddonFolder']));
			$this->name_label = undecode_html(bab_translate("Quizz name:", $GLOBALS['babAddonFolder']));
			$this->description_label = undecode_html(bab_translate("Description:", $GLOBALS['babAddonFolder']));
			$this->begin_date_label = undecode_html(bab_translate("Begin date:", $GLOBALS['babAddonFolder']));
			$this->end_date_label = undecode_html(bab_translate("End date:", $GLOBALS['babAddonFolder']));
			$this->questions_label = undecode_html(bab_translate("Questions and proposed answers list", $GLOBALS['babAddonFolder']));
			$this->answers_label = undecode_html(bab_translate("Answers:", $GLOBALS['babAddonFolder']));
			$this->awaited_answer_label = undecode_html(bab_translate("Awaited answer:", $GLOBALS['babAddonFolder']));
			$this->score_label = undecode_html(bab_translate("Score", $GLOBALS['babAddonFolder']));
			$this->max_question_label = undecode_html(bab_translate("Maximum points for the question:", $GLOBALS['babAddonFolder']));
			$this->synthesis_label = undecode_html(bab_translate("Synthesis", $GLOBALS['babAddonFolder']));
			$this->max_quizz_label = undecode_html(bab_translate("Maximum points for the quizz:", $GLOBALS['babAddonFolder']));
			$this->valuation_label = undecode_html(bab_translate("Valuations:", $GLOBALS['babAddonFolder']));
			
			$this->print_label = undecode_html(bab_translate("Structure print", $GLOBALS['babAddonFolder']));
			$this->view_label = undecode_html(bab_translate("View quizz answers", $GLOBALS['babAddonFolder']));
			$this->select_label = undecode_html(bab_translate("Select an other quizz", $GLOBALS['babAddonFolder']));
			
			$this->bgcolor = true;
			
			$this->res1 = $babDB->db_query("
			SELECT 
			`id`,
			`question`,
			`id_typequest`
			FROM
			`qui_question` 
			WHERE
			`id_quizz` = '".$babDB->db_escape_string($this->quizz_id)."'
			AND 
			`active` = 'Y'
			ORDER BY
			`ordering`
			");
			$this->count1 = $babDB->db_num_rows($this->res1);
			
			$this->res2 = $babDB->db_query("
			SELECT 
			`msg`, 
			`limit_up`, 
			`limit_down` 
			FROM 
			`qui_msg_custom` 
			WHERE 
			`id_quizz` = '".$babDB->db_escape_string($this->quizz_id)."'
			ORDER BY
			`limit_up`
			");
			$this->count2 = $babDB->db_num_rows($this->res2);
			
			$this->max_quizz = 0;
		}
		////////////////////////////////////////////////////
		function getnext1()
		{
			global $babDB;
			static $k=0;
			if ( $k < $this->count1 )
			{
				$this->bgcolor = !$this->bgcolor;
				
				$arr = $babDB->db_fetch_array($this->res1);
				$id = $arr['id'];
				$this->question = $arr['question'];
				$id_typequest = $arr['id_typequest'];
				$res = $babDB->db_query("
				SELECT `answer`,
				`score`
				FROM
				`qui_answer`
				WHERE
				`id_question` = '".$babDB->db_escape_string($id)."'
				AND
				`active` = 'Y'
				");
				
				$count = $babDB->db_num_rows($res);
				
				switch ($id_typequest)
				{
					case 1:
						$this->question_label = undecode_html(sprintf(bab_translate("Question %s:", $GLOBALS['babAddonFolder']), $k + 1));
						$this->string = "<tr><th>".$this->answers_label."</th><th width=\"30\">".$this->score_label."</th></tr>";
						$this->max_question = 0;
						for ($j = 0; $j < $count; $j++)
						{
							$arr = $babDB->db_fetch_array($res);
							$this->subsidiary_question_flag = false;
							$answer = $arr['answer'];
							$score = $arr['score'];
							$this->string .= "<tr>\n";
							$this->string .= "<td>".$answer."</td>\n";
							$this->string .= "<td width=\"30\" align=\"center\">".$score."</td>\n";
							$this->string .= "</tr>\n";
							$this->max_question = max($this->max_question, $score);
						}
						$this->max_quizz = $this->max_quizz + $this->max_question;
						break;
					case 2:
						$this->question_label = undecode_html(bab_translate("Tiebreaker:", $GLOBALS['babAddonFolder']));

						$this->subsidiary_question_flag = true;
						$arr = $babDB->db_fetch_array($res);
						$answer = $arr['answer'];
						$this->string = "<tr><td colspan=\"2\"><b>".$this->awaited_answer_label."</b> ".$answer."</td><tr>\r\n";
						break;
				}
				
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
		////////////////////////////////////////////////////
		function getnext2()
		{
			global $babDB;
			static $k=0;
			if ( $k < $this->count2 )
			{
				$arr = $babDB->db_fetch_array($this->res2);
				$msg = $arr['msg'];
				$limit_up = $arr['limit_up'];
				$limit_down = $arr['limit_down'];
				$points_up = floor($limit_up * $this->max_quizz /100);
				if ($points_up < 2) $points_up = undecode_html(sprintf(bab_translate("%s point", $GLOBALS['babAddonFolder']), $points_up)); else $points_up = undecode_html(sprintf(bab_translate("%s points", $GLOBALS['babAddonFolder']), $points_up));
				$points_down = floor($limit_down * $this->max_quizz /100);
				if ($points_down < 2) $points_down = undecode_html(sprintf(bab_translate("%s point", $GLOBALS['babAddonFolder']), $points_up)); else $points_down = undecode_html(sprintf(bab_translate("%s points", $GLOBALS['babAddonFolder']), $points_down));
				$this->synthesis = undecode_html(sprintf(bab_translate("From %s  &#37;(%s) to %s  &#37; (%s): %s", $GLOBALS['babAddonFolder']), $limit_up, $points_up, $limit_down, $points_down, $msg));
				
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
		////////////////////////////////////////////////////
	}
	
	$obj= new structure_display_form_class();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS["babAddonHtmlPath"]."user.html", "structure_display"));
}

function quizz_select_form()
{
	global $babBody;
	class quizz_select_form_class
	{
		function quizz_select_form_class()
		{
			global $babBody;
			global $babDB;
			
			$this->res = $babDB->db_query("
			SELECT
			`id`,
			`name`
			FROM
			`qui_quizz`
			WHERE 1
			");
			
			$this->count = $babDB->db_num_rows($this->res);
			
			if ($this->count === 0)
			{
				$babBody->addError(undecode_html(bab_translate("No quizz", $GLOBALS['babAddonFolder'])));
			}
			else
			{
				$babBody->addError(undecode_html(bab_translate("Select a quizz in the list below and validate", $GLOBALS['babAddonFolder'])));
				$this->choice_label = undecode_html(bab_translate("Choice in the list", $GLOBALS['babAddonFolder']));
				$this->validate_label = undecode_html(bab_translate("Validate", $GLOBALS['babAddonFolder']));
			}	
		}
		
		////////////////////////////////////////////////////
		function getnext()
		{
			global $babDB;
			static $k=0;
			if ( $k < $this->count )
			{
				$arr  = $babDB->db_fetch_array($this->res);
				$this->id = $arr['id'];
				$this->name = $arr['name'];
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
		////////////////////////////////////////////////////		
	}
	$obj= new quizz_select_form_class();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS["babAddonHtmlPath"]."user.html", "quizz_select"));
}

$res = $babDB->db_query("
SELECT
`id_object`
FROM
`qui_gest_groups`
WHERE
1
");
if ($babDB->db_num_rows($res) > 0)
{
	$arr = $babDB->db_fetch_array($res);
	$id_object = $arr['id_object'];
}
else
{
	$id_object = 1;
}
	
if (bab_isAccessValid('qm_access_groups', $id_object))
{
	$submit_flag = bab_pp('submit_flag', '');
	if (empty($submit_flag))
	{
		$babBody->title = undecode_html(bab_translate("Quizz select", $GLOBALS["babAddonFolder"]));
		quizz_select_form();
	}
	else
	{
		$quizz_id = bab_pp('quizz_id', '');
		if (empty($quizz_id))
		{
			$babBody->title = undecode_html(bab_translate("Quizz select", $GLOBALS["babAddonFolder"]));
			quizz_select_form();
		}
		else
		{
			$action = bab_pp('action', '');
			$res = $babDB->db_query("
			SELECT 
			`name`
			FROM 
			`qui_quizz` 
			WHERE 
			`id` = '".$babDB->db_escape_string($quizz_id)."'
			");
			$arr = $babDB->db_fetch_array($res);
			$name = $arr['name'];
			if (empty($action))
			{
				$babBody->title = undecode_html(sprintf(bab_translate("Structure of %s quizz display", $GLOBALS["babAddonFolder"]), $name));
				structure_display_form();
			}
			else
			{
				$babBody->title = undecode_html(sprintf(bab_translate("Answers display of the %s quizz", $GLOBALS["babAddonFolder"]), $name));
				answers_display_form();
			}
			
		}
	}
	
	
}
else
{
	exit;
}	
?>