<?php
require_once 'base.php';

require_once $GLOBALS['babAddonPhpPath'].'functions.php';

function quizz_management_getAdminSectionMenus(&$url, &$text)
{
	return false;
}
 
function quizz_management_getUserSectionMenus(&$url, &$text)
{
	return false;
}
 
function quizz_management_onSectionCreate(&$title, &$content)
{
	global $babDB;
	
	$res = $babDB->db_query("
	SELECT
	`id_object`
	FROM
	`qui_gest_groups`
	WHERE
	1
	");
	if ($babDB->db_num_rows($res) > 0)
	{
		$arr = $babDB->db_fetch_array($res);
		$id_object = $arr['id_object'];
	}
	else
	{
		$id_object = 1;
	}
	if (bab_isAccessValid('qm_access_groups', $id_object))
	{
		$title = undecode_html(bab_translate("Quizz management", $GLOBALS['babAddonFolder']));
		$content = "<ul>\n";
		$content .= "<li><a href='".$GLOBALS['babAddonUrl']."user&idx=view' title = '".undecode_html(bab_translate("Access to the quizz results", $GLOBALS['babAddonFolder']))."'>".undecode_html(bab_translate("Access to results", $GLOBALS['babAddonFolder']))."</a></li>\n";
		$content .= "</ul>\n";
		return true;
	}
	else
	{
		return false;
	}
}

function quizz_management_upgrade($version_base,$version_ini)
{
	global $babDB;
	global $babBody;	
	
	if (bab_isTable("qui_typequest"))
	{
		$res= $babDB->db_query("
		UPDATE
		`qui_typequest`
		SET
		`description` = 'Question subsidiaire'
		WHERE
		`name` = 'subsidiary';
		");
	}
	
	
	if ( !bab_isTable("qm_access_groups")) 
	{ 
		$res = $babDB->db_query(" 
		CREATE TABLE `qm_access_groups` (
		`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		`id_object` INT(11) UNSIGNED DEFAULT '0' NOT NULL,
		`id_group` INT(11) UNSIGNED DEFAULT '0' NOT NULL,
		PRIMARY KEY ( `id` ))
		");
	}
	
	$res = $babDB->db_query("
	SELECT
	`id`
	FROM
	`qm_access_groups`
	WHERE
	1
	");
	
	if ($babDB->db_num_rows($res) === 0)
	{
		$res = $babDB->db_query("
		INSERT
		INTO
		`qm_access_groups`
		(
			`id_object`,
			`id_group`
		)
		SELECT
		`id_object`,
		`id_group`
		FROM
		`qui_gest_groups`
		WHERE
		1
		");
	}
	
	return true;
}

function quizz_management_onDeleteAddon()
{
	return true;
}
?>